// Generated by Create API
// https://github.com/CreateAPI/CreateAPI
//
// swift-format-ignore-file

import Foundation
import URLQueryEncoder

extension Resources.V1.AppInfoLocalizations {
    public func id(_ id: String) -> WithID {
        WithID(path: "\(path)/\(id)")
    }

    public struct WithID {
        /// Path: `/v1/appInfoLocalizations/{id}`
        public let path: String

        public func get(fieldsAppInfoLocalizations: [FieldsAppInfoLocalizations]? = nil, include: [Include]? = nil) -> Request<_Specification.AppInfoLocalizationResponse> {
            Request(method: "GET", url: path, query: makeGetQuery(fieldsAppInfoLocalizations, include), id: "appInfoLocalizations-get_instance")
        }

        private func makeGetQuery(_ fieldsAppInfoLocalizations: [FieldsAppInfoLocalizations]?, _ include: [Include]?) -> [(String, String?)] {
            let encoder = URLQueryEncoder(explode: false)
            encoder.encode(fieldsAppInfoLocalizations, forKey: "fields[appInfoLocalizations]")
            encoder.encode(include, forKey: "include")
            return encoder.items
        }

        public enum FieldsAppInfoLocalizations: String, Codable, CaseIterable {
            case appInfo
            case locale
            case name
            case privacyChoicesURL = "privacyChoicesUrl"
            case privacyPolicyText
            case privacyPolicyURL = "privacyPolicyUrl"
            case subtitle
        }

        public enum Include: String, Codable, CaseIterable {
            case appInfo
        }

        public func patch(_ body: _Specification.AppInfoLocalizationUpdateRequest) -> Request<_Specification.AppInfoLocalizationResponse> {
            Request(method: "PATCH", url: path, body: body, id: "appInfoLocalizations-update_instance")
        }

        public var delete: Request<Void> {
            Request(method: "DELETE", url: path, id: "appInfoLocalizations-delete_instance")
        }
    }
}
